//+------------------------------------------------------------------+
//|                                                    my_1x5_ea.mq4 |
//|                       Copyright ?2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <stdlib.mqh>

//---- input parameters
extern double    lots=0.1;
extern double    takeProfit=100.0;
extern double    stopLoss=20.0;
extern double    slippage=3.0;
extern string    nameEA="1x5_stra";
extern int       TradeHour=0;

double fopen, fclose, sopen, sclose, topen, tclose;
bool fbuy = false, fsell = false, sbuy = false, ssell = false, tbuy = false, tsell = false;
double realSL, realTP;
int cnt, ticket;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 
   if (TimeHour(CurTime())==TradeHour && TimeMinute(CurTime())==0)  {


      int totalOrders = OrdersTotal();
      int numPos = 0;
      
       for(cnt=0; cnt<totalOrders; cnt++) {        // scan all orders and positions...
         OrderSelect(cnt, SELECT_BY_POS);         // the next line will check for ONLY market trades, not entry orders
         if(OrderSymbol() == Symbol() && OrderType() <= OP_SELL) {   // only look for this symbol,    
         numPos++;
         }
         }

   if(AccountFreeMargin()<(1000*lots)) return(0);
      // If there is no open trade
   if(numPos <1) { 

   calculateIndicators();

   if (fbuy || sbuy || tbuy) buying();
   if (fsell || ssell || tsell) selling();       

// || tbuy
// || tsell      
         
                
   }
}     
//----
   return(0);
  }

void calculateIndicators() {
   fopen    = Open[1];
   fclose   = Close[1];
   sopen    = Open[2];
   sclose   = Close[2];
   topen    = Open[3];
   tclose   = Close[3];
   
   fbuy  = (fopen<fclose && ((fclose-fopen)>=(10*Point)));
   fsell = (fopen>fclose && ((fopen-fclose)>=(10*Point)));
   sbuy  = (((fclose-fopen)<=(10*Point)) && ((fopen-fclose)<=(10*Point)) && sopen<sclose && ((sclose-sopen)>=(10*Point)));
   ssell = (((fclose-fopen)<=(10*Point)) && ((fopen-fclose)<=(10*Point)) && sopen>sclose && ((sopen-sclose)>=(10*Point)));
   tbuy  = (((fclose-fopen)<=(10*Point)) && ((fopen-fclose)<=(10*Point)) && ((sclose-fopen)<=(10*Point)) && ((sopen-fclose)<=(10*Point)) && topen<tclose && ((tclose-topen)>=(10*Point)));
   tsell = (((fclose-fopen)<=(10*Point)) && ((fopen-fclose)<=(10*Point)) && ((sclose-fopen)<=(10*Point)) && ((sopen-fclose)<=(10*Point)) && topen>tclose && ((topen-sclose)>=(10*Point)));
}

void buying() {
         if(stopLoss > 0)
            realSL = Ask - stopLoss * Point;
         if(takeProfit > 0)
            realTP = Ask + takeProfit * Point;
         ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,slippage,realSL,realTP,"My EA",12345,0,Red);  // BUY
         if(ticket < 0) {
            prtAlert("OrderSend (" + nameEA + ") failed with error #" + GetLastError() + " --> " + ErrorDescription(GetLastError()));
         } 
         else {
            prtAlert("Day Trading: Buying"); 
         }
      }
      
void selling() {
         if(stopLoss > 0)
            realSL = Bid + stopLoss * Point;
         if(takeProfit > 0)
            realTP = Bid - takeProfit * Point;
         ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,slippage,realSL,realTP,"My EA",12345,0,Red);  // SELL
         if(ticket < 0) {
            prtAlert("OrderSend (" + nameEA + ") failed with error #" + GetLastError() + " --> " + ErrorDescription(GetLastError()));
         } 
         else {
            prtAlert("Day Trading: Selling"); 
         }
      }


void prtAlert(string str = "") {
   Print(Symbol() + " - " + str);
   Alert(Symbol() + " - " + str);
   SpeechText(addSpaces(Symbol()) + " - " + str,SPEECH_ENGLISH);
   // SendMail(Symbol(),str);
}

string addSpaces(string str = "") {
   int length = StringLen(str);
   string sp  = "";
   for(int i=0; i<length; i++)
      sp = sp + StringSubstr(str,i,1) + " ";
   return (sp);
   }